package ru.dbotthepony.mc.otm.item.armor

import net.minecraft.sounds.SoundEvent
import net.minecraft.sounds.SoundEvents
import net.minecraft.world.entity.EquipmentSlot
import net.minecraft.world.item.ArmorItem
import net.minecraft.world.item.ArmorMaterial
import net.minecraft.world.item.crafting.Ingredient
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.registry.MItemTags

private object SimpleTritaniumArmorMaterial : ArmorMaterial {
	override fun getDurabilityForSlot(p_40410_: EquipmentSlot): Int {
		return when (p_40410_) {
			EquipmentSlot.HEAD -> 380
			EquipmentSlot.CHEST -> 590
			EquipmentSlot.LEGS -> 500
			EquipmentSlot.FEET -> 420
			else -> throw IllegalArgumentException("yo dude what the fuck $p_40410_")
		}
	}

	override fun getDefenseForSlot(p_40411_: EquipmentSlot): Int {
		return when (p_40411_) {
			EquipmentSlot.FEET -> 2
			EquipmentSlot.LEGS -> 6
			EquipmentSlot.CHEST -> 7
			EquipmentSlot.HEAD -> 2
			else -> throw IllegalArgumentException("yo dude what the fuck $p_40411_")
		}
	}

	override fun getEnchantmentValue() = 9
	override fun getEquipSound(): SoundEvent = SoundEvents.ARMOR_EQUIP_IRON
	override fun getRepairIngredient(): Ingredient = Ingredient.of(MItemTags.TRITANIUM_INGOTS)

	const val ID = "${OverdriveThatMatters.MOD_ID}:simple_tritanium_armor"

	override fun getName(): String = ID
	override fun getToughness() = 0.3f
	override fun getKnockbackResistance() = 0f
}

class SimpleTritaniumArmorItem(slot: EquipmentSlot) : ArmorItem(SimpleTritaniumArmorMaterial, slot, Properties().stacksTo(1)) {
}
